/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cviceni04;
import java.util.*;

/**
 *
 * @author Kuba
 */

class Prvek implements Comparable<Prvek>{
    int cena, vaha;

    Prvek(int c, int v){
        cena = c;
        vaha = v;
    }

    //--- Porovnava podle ceny
    public int compareTo(Prvek p){
        return this.cena - p.cena;
    }

    public String toString(){
        return("cena=" + cena + " vaha=" + vaha + "\n");
    }
}

class KomparatorVaha implements Comparator<Prvek>{
    public int compare(Prvek p1, Prvek p2){
        return p1.vaha - p2.vaha;
    }
}

public class VyhledavaniArrays_4 {
    static Prvek[] pole;

    public static void main(String[] args) {
        pole = new Prvek[5];
        pole[0] = new Prvek(100, 30);
        pole[1] = new Prvek(400, 20);
        pole[2] = new Prvek(500, 40);
        pole[3] = new Prvek(200, 50);
        pole[4] = new Prvek(300, 60);
        int k, hledanaCena, hledanaVaha;

        //--- Hledani podle ceny
        hledanaCena = 500;
        System.out.println("\nHledam prvek s cenou " + hledanaCena);
        k = Arrays.binarySearch(pole, new Prvek(hledanaCena, 0));   //--- vaha nas nezajima
        if(k >= 0)
            System.out.println("pole[" + k + "]: cena=" + pole[k].cena + " vaha=" + pole[k].vaha);
        else
            System.out.println("Prvek s cenou " + hledanaCena + " v seznamu neni");

        //--- Hledani podle vahy
        hledanaVaha = 20;
        Arrays.sort(pole, new KomparatorVaha());
        System.out.println("\nHledam prvek s vahou " + hledanaVaha);
        k = Arrays.binarySearch(pole, new Prvek(0, hledanaVaha), new KomparatorVaha()); //--- Co je tady spatne?
        if(k >= 0)
            System.out.println("pole[" + k + "]: cena=" + pole[k].cena + " vaha=" + pole[k].vaha);
        else
            System.out.println("Prvek s vahou " + hledanaVaha + " v seznamu neni");

//        //--- Razeni prirozene
//        System.out.print("\nPrirozene razeni podle ceny:\n----------------------------\n");
//        Arrays.sort(pole);
//        System.out.println(Arrays.asList(pole));
//
//        //--- Razeni absolutni
//        System.out.print("\nAbsolutni razeni podle vahy:\n----------------------------\n");
//        Arrays.sort(pole, new KomparatorVaha());
//        System.out.println(Arrays.asList(pole));

    }
}
